/*
 * basic.c
 *
 * Created: 2014-02-07 15:22:31
 *  Author: dsosnowski
 */ 

#define F_CPU 4000000
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "defs.h"
#include "basic.h"

void InputScan(void);
void Action(void);


struct {
	char t_on1;
	char t_on2;
	char action;
	char mode;
}inputs;



//--------------------------------------------------
void InputScan(void)
{
	char temp;		//idle

	if (IN1_GET == 0)
	{
		if (inputs.t_on1 < 0xFF) inputs.t_on1++;
		if (inputs.t_on1 == INPUT_TRESHOLD) inputs.action |= 1;
		if (inputs.mode == 1)
		{
			if (inputs.t_on1 > INPUT_TRESHOLD) inputs.action |= 1;//pulse mode
		} 
	}
	else
	{
		inputs.t_on1 = 0;		
	}

	if (IN2_GET == 0)
	{
		if (inputs.t_on2 < 0xFF) inputs.t_on2++;
		if (inputs.t_on2 == INPUT_TRESHOLD) inputs.action |= 2;
		if (inputs.mode == 1)
		{
			if (inputs.t_on2 > INPUT_TRESHOLD) inputs.action |= 2;//pulse mode
		} 
	}
	else
	{
		inputs.t_on2 = 0;		
	}
}

//--------------------------------------------------
//input system.command
//param. system.mode
void Action(void)
{
		if (inputs.mode == 0)				//normal mode
		{
			if (inputs.action & 1)	//command = 1
			{
				if (OUT1_GET)	//if set
					OUT1_OFF;				//OFF
				else
					OUT1_SET;				//SET
			}
			if (inputs.action & 2)	//command = 2
			{
				if (OUT2_GET)	//if set
					OUT2_OFF;				//OFF
				else
					OUT2_SET;				//SET
			}
		}

		if (inputs.mode == 1)				//pulse mode
		{
			if (inputs.action & 1)	//command = 1
				OUT1_SET;
			else
				OUT1_OFF;
		
			if (inputs.action & 2)	//command = 2
				OUT2_SET;
			else
				OUT2_OFF;
		}	
		inputs.action = 0;			
}

