/*
 * decode.h
 *
 * Created: 2014-02-07 14:00:14
 *  Author: dsosnowski
 */ 


#ifndef DECODE_H_
#define DECODE_H_


void DecodeInt(void);
void Decode(void);


//START x 2, ADR x 8, CODE1 x 5, CODE2 x 5, NULL x 2

/*
#define TIMER_STOP			TCCR0B = 0
//#define TIMER_START			TCCR0B = (1<<CS01 | 1<<CS00);
#define TIMER_START			TCCR0B = (1<<CS02);
#define TIMER_VAL			TCNT0
#define TIMER_CLEAR			TCNT0 = 0
#define TIMER_RESET			GTCCR = (1<<PSR10)
*/
#define TIMER_STOP			TCCR1B = (1<<WGM13 | 1<<WGM12);
#define TIMER_START			TCCR1B = (1<<WGM13 | 1<<WGM12 | 1<<CS11);
#define TIMER_VAL			TCNT1L
#define TIMER_CLEAR			TCNT1 = 0
#define TIMER_RESET			GTCCR = (1<<PSR10)

#define CODE_LENGTH			29
#define CODE_SPECIAL_INDEX	1
#define CODE_START_INDEX	2
#define CODE_SYNCHRO_INDEX	3
#define CODE_ADR_INDEX		8
#define CODE_CODE1_INDEX	16
#define CODE_CODE2_INDEX	21
#define CODE_L_INDEX		26

//basic cycle 12,5
#define STATE_L_MIN			10
//12.5
#define STATE_L_MAX			14
#define STATE_H_MIN			22
//25
#define STATE_H_MAX			27
#define STATE_SPEC_MIN		50
//62,5
#define STATE_SPEC_MAX		70

#define STATE_PASSIVE_MIN	22
//25
#define STATE_PASSIVE_MAX	27

#define PASSIVE_THRESHOLD	3
#define ACTIVE_THRESHOLD	3




#define NULL_BIT			0
#define H_BIT				1
#define L_BIT				2
#define SPECIAL_BIT			3

#define STATUS_IDLE			0
#define STATUS_INPROGRESS	1
#define STATUS_COMPLETE		2

#define COMMAND_EMPTY		0
#define COMMAND_READY		1
#define COMMAND_ERROR		2

#define MODULE_ADDRESS		54
#define COMMAND_1			11
#define COMMAND_2			6
#define COMMAND_CLR			0			



#endif /* DECODE_H_ */